package com.agiledeveloper;

//Compile this code and then run javap -c Sample to view the bytecode
//study the various invoke method calls. If we mark the instanceMethod final,
//how does the byte code change? Think about it before marking that method final
//and taking a peek at the bytecode generated.
public class Sample implements Comparable<Sample> {
  public double instanceMethod(double value) {
    System.out.println("instanceMethod");
    return value * 2;
  }

  public static void staticMethod() {
    System.out.println("staticMethod");
  }

  public static void main(String[] args) {
    Sample.staticMethod();

    Sample sample = new Sample();
    sample.instanceMethod(2);
    Comparable<Sample> comparable = sample;
    comparable.compareTo(sample);
  }

  @Override
  public int compareTo(Sample o) {
    return 0;
  }
}













