package com.agiledeveloper;

class Base {
  public void foo1(double value) {
    System.out.println("Base::foo1");
  }

  public void foo2(double value) {
    System.out.println("Base::foo2");
  }
}

class Derived extends Base {
  public void foo1(double value) {
    System.out.println("Derived::foo1");
  }

  public void foo2(int value) {
    System.out.println("Derived::foo2");
  }
}

public class Sample {
  public static void main(String[] args) {
    Base b = new Derived();

    b.foo1(5);
    b.foo1(5.0);

    b.foo2(5);
    b.foo2(5.0);

    //This this code in Java:
    /*
      Derived::foo1
      Derived::foo1
      Base::foo2
      Base::foo2
     */

    //Thy this code in Groovy:
    /*
      Derived::foo1
      Derived::foo1
      Derived::foo2
      Base::foo2
    */

    //Groovy support multimethods.
    //Multimethods are polymorphism on steroids.
    //We don't have to check instanceof and can overload
    //functions with different parameters easily to handle
    //different data types more easily.
  }
}
