package com.agiledeveloper;

import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodType;

class Base {
  public void foo1(double value) {
    System.out.println("Base::foo1");
  }

  public void foo2(double value) {
    System.out.println("Base::foo2");
  }
}

class Derived extends Base {
  public void foo1(double value) {
    System.out.println("Derived::foo1");
  }

  public void foo2(int value) {
    System.out.println("Derived::foo2");
  }
}

public class Sample {
  public static void main(String[] args) throws Throwable {
    Base b = new Derived();

    b.foo1(5);
    b.foo1(5.0);

    System.out.println("--------------");
    b.foo2(5);
    b.foo2(5.0);

    System.out.println("--------------");
    callMultiMethod(b, 5, int.class);
    callMultiMethod(b, 5.0, double.class);
  }

  private static void callMultiMethod(Object instance, Object parameter, Class<?> parameterType) throws Throwable {
    MethodHandles.Lookup lookup = MethodHandles.lookup();
    MethodHandle foo2Handle = lookup.findVirtual(
        instance.getClass(), "foo2", MethodType.methodType(
        void.class, parameterType));

    foo2Handle.bindTo(instance).invoke(parameter);
  }
  /*
      Derived::foo1
      Derived::foo1
      --------------
      Base::foo2
      Base::foo2
      --------------
      Derived::foo2
      Base::foo2
   */
}
